﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls.UI.Scheduler.Dialogs;
using Telerik.WinControls;

namespace GermanRadSchedulerLocalization_Q3_2010
{
    public partial class CustomEditRecurrenceDialog : EditRecurrenceDialog
    {
        public CustomEditRecurrenceDialog( IEvent recurringAppointment , ISchedulerData schedulerData )
            : base( recurringAppointment , schedulerData )
        {
            InitializeComponent( );

            // Rearrange the Controls on the EditRecurrenceDialog
            RearrangeControlsInDialog( );
        }

        private void RearrangeControlsInDialog( )
        {
            // --------------- grpAppointmentTime -------------------------------------------------
            RearrangeControlsInGroupBoxAppointmentTime( );

            // --------------- grpRange -----------------------------------------------------------
            RearrangeControlsInGroupBoxRange( );

            // --------------- recurrenceGroupBox -------------------------------------------------
            GroupBox recurrenceGroupBox = ( GroupBox ) this.Controls[ "recurrenceGroupBox" ];

            RadRadioButton radioYearly = ( RadRadioButton ) recurrenceGroupBox.Controls[ "radioYearly" ];
            RadRadioButton radioMonthly = ( RadRadioButton ) recurrenceGroupBox.Controls[ "radioMonthly" ];
            RadRadioButton radioWeekly = ( RadRadioButton ) recurrenceGroupBox.Controls[ "radioWeekly" ];
            RadRadioButton radioDaily = ( RadRadioButton ) recurrenceGroupBox.Controls[ "radioDaily" ];

            RearrangeControlsInGroupBoxRecurrence( radioYearly , radioMonthly , radioWeekly , radioDaily );

            // --------------- DailyRecurrenceSettings --------------------------------------------
            RearrangeControlsInDailySettings( radioDaily );

            // --------------- MonthlyRecurrenceSettings ------------------------------------------
            RearrangeControlsInMonthlySettings( radioMonthly );

            // --------------- YearlyRecurrenceSettings -------------------------------------------
            RearrangeControlsInYearlySettings( radioYearly );

            // --------------- WeeklyRecurrenceSettings -------------------------------------------
            RearrangeControlsInWeeklySettings( radioWeekly );
        }

        private void RearrangeControlsInWeeklySettings( RadRadioButton radioWeekly )
        {
            WeeklyRecurrenceSettings Weekly = ( WeeklyRecurrenceSettings ) this.radioToSettingsDictionary[ radioWeekly ];

            RadLabel lblRecurEvery = ( RadLabel ) Weekly.Controls[ "lblRecurEvery" ];

            lblRecurEvery.Location = new Point( 10 , 4 );

            RadCheckBox chkSunday = ( RadCheckBox ) Weekly.Controls[ "chkSunday" ];

            chkSunday.Location = new Point( 147 , 61 );

            RadCheckBox chkMonday = ( RadCheckBox ) Weekly.Controls[ "chkMonday" ];

            chkMonday.Location = new Point( 4 , 37 );

            RadCheckBox chkTuesday = ( RadCheckBox ) Weekly.Controls[ "chkTuesday" ];

            chkTuesday.Location = new Point( 79 , 37 );

            RadCheckBox chkWednesday = ( RadCheckBox ) Weekly.Controls[ "chkWednesday" ];

            chkWednesday.Location = new Point( 147 , 37 );

            RadCheckBox chkThursday = ( RadCheckBox ) Weekly.Controls[ "chkThursday" ];

            chkThursday.Location = new Point( 219 , 37 );
            chkThursday.Size = new Size( 80 , 17 );

            RadCheckBox chkFriday = ( RadCheckBox ) Weekly.Controls[ "chkFriday" ];

            chkFriday.Location = new Point( 4 , 61 );

            RadCheckBox chkSaturday = ( RadCheckBox ) Weekly.Controls[ "chkSaturday" ];

            chkSaturday.Location = new Point( 79 , 61 );
        }

        private void RearrangeControlsInYearlySettings( RadRadioButton radioYearly )
        {
            YearlyRecurrenceSettings Yearly = ( YearlyRecurrenceSettings ) this.radioToSettingsDictionary[ radioYearly ];

            RadRadioButton radioDayOfMonth = ( RadRadioButton ) Yearly.Controls[ "radioDayOfMonth" ];

            radioDayOfMonth.Location = new Point( 10 , 4 );

            RadRadioButton radioWeekOfMonth = ( RadRadioButton ) Yearly.Controls[ "radioWeekOfMonth" ];

            radioWeekOfMonth.Location = new Point( 10 , 36 );
            radioWeekOfMonth.Size = new Size( 70 , 16 );

            RadComboBox cmbWeekNumber = ( RadComboBox ) Yearly.Controls[ "comboBoxWeekNumber" ];

            cmbWeekNumber.Location = new Point( 60 , 34 );
            cmbWeekNumber.Size = new Size( 84 , 20  );

            RadComboBox cmbMonth1 = ( RadComboBox ) Yearly.Controls[ "comboBoxMonth1" ];

            cmbMonth1.Location = new Point( 110 , 2 );

            RadSpinEditor spinDayNumber = ( RadSpinEditor ) Yearly.Controls[ "spinDayNumber" ];

            spinDayNumber.Location = new Point( 60 , 2 );
        }

        private void RearrangeControlsInMonthlySettings( RadRadioButton radioMonthly )
        {
            MonthlyRecurrenceSettings Monthly = ( MonthlyRecurrenceSettings ) this.radioToSettingsDictionary[ radioMonthly ];

            RadRadioButton radioDayOfMonth = ( RadRadioButton ) Monthly.Controls[ "radioDayOfMonth" ];

            radioDayOfMonth.Location = new Point( 10 , 4 );

            RadLabel lblDayOfMonth = ( RadLabel ) Monthly.Controls[ "lblDayOfMonth" ];

            lblDayOfMonth.Location = new Point( 100 , 5 );

            RadSpinEditor spinInterval1 = ( RadSpinEditor ) Monthly.Controls[ "spinInterval1" ];

            spinInterval1.Location = new Point( 162 , 2 );

            RadLabel lblMonths1 = ( RadLabel ) Monthly.Controls[ "lblMonths1" ];

            lblMonths1.Location = new Point( 213 , 5 );

            RadRadioButton radioWeekOfMonth = ( RadRadioButton ) Monthly.Controls[ "radioWeekOfMonth" ];

            radioWeekOfMonth.Location = new Point( 10 , 34 );

        }

        private void RearrangeControlsInDailySettings( RadRadioButton radioDaily )
        {
            DailyRecurrenceSettings Daily = ( DailyRecurrenceSettings ) this.radioToSettingsDictionary[ radioDaily ];

            RadRadioButton radioEveryWeekDay = ( RadRadioButton ) Daily.Controls[ "radioEveryWeekDay" ];

            radioEveryWeekDay.Location = new Point( 10 , 36 );
            radioEveryWeekDay.Size = new Size( 150 , 16 );

            RadRadioButton radioEveryDay = ( RadRadioButton ) Daily.Controls[ "radioEveryDay" ];

            radioEveryDay.Location = new Point( 10 , 4 );
        }

        private static void RearrangeControlsInGroupBoxRecurrence( RadRadioButton radioYearly , RadRadioButton radioMonthly , RadRadioButton radioWeekly , RadRadioButton radioDaily )
        {
            radioYearly.Size = new Size( 70 , 16 );
            radioMonthly.Size = new Size( 70 , 16 );
            radioWeekly.Size = new Size( 80 , 16 );
            radioDaily.Size = new Size( 70 , 16 );
        }

        private void RearrangeControlsInGroupBoxRange( )
        {
            GroupBox grpRange = ( GroupBox ) this.Controls[ "groupBoxRange" ];
            RadDateTimePicker dateStart = ( RadDateTimePicker ) grpRange.Controls[ "dateStart" ];

            dateStart.Location = new Point( 65 , 19 );
            dateStart.Size = new Size( 144 , 20 );

            RadRadioButton radioNoEndDate = ( RadRadioButton ) grpRange.Controls[ "radioNoEndDate" ];

            radioNoEndDate.Size = new Size( 100 , 16 );

            RadRadioButton radioEndAfter = ( RadRadioButton ) grpRange.Controls[ "radioEndAfter" ];

            radioEndAfter.Size = new Size( 80 , 16 );

            RadRadioButton radioEndBy = ( RadRadioButton ) grpRange.Controls[ "radioEndBy" ];

            radioEndBy.Size = new Size( 80 , 16 );

            RadLabel lblOccurrences = ( RadLabel ) grpRange.Controls[ "labelOccurrences" ];

            lblOccurrences.Size = new Size( 80 , 16 );
        }

        private void RearrangeControlsInGroupBoxAppointmentTime( )
        {
            GroupBox grpAppointmentTime = ( GroupBox ) this.Controls[ "groupBoxAppointmentTime" ];
            RadDateTimePicker timeStart = ( RadDateTimePicker ) grpAppointmentTime.Controls[ "timeStart" ];

            timeStart.Location = new Point( 65 , 19 );
        }

        /*
        protected override void CreateRadioToSettingsDictionary( )
        {
            this.radioToSettingsDictionary = new Dictionary<RadRadioButton , IRecurrenceRuleSettingsControl>( );

            this.radioToSettingsDictionary.Add( this.radioDaily , new CustomDailyRecurrenceSettings( ) );
            this.radioToSettingsDictionary.Add( this.radioWeekly , new CustomWeeklyRecurrenceSettings( ) );
            this.radioToSettingsDictionary.Add( this.radioMonthly , new CustomMonthlyRecurrenceSettings( ) );
            this.radioToSettingsDictionary.Add( this.radioYearly , new CustomYearlyRecurrenceSettings( ) );
        }
        */
    }
}
